#include <Adafruit_GFX.h>
#include <Adafruit_NeoMatrix.h>
#include <Adafruit_NeoPixel.h>
#ifndef PSTR
 #define PSTR 
#endif

#define PIN 6

Adafruit_NeoMatrix matrix = Adafruit_NeoMatrix(16, 16, PIN, NEO_MATRIX_BOTTOM + NEO_MATRIX_LEFT +  NEO_MATRIX_ROWS + NEO_MATRIX_ZIGZAG, NEO_GRB  + NEO_KHZ800);

const uint16_t colors[] = {
  matrix.Color(255, 0, 0), matrix.Color(0, 255, 0), matrix.Color(0, 0, 255), matrix.Color(0, 255, 255), matrix.Color(255, 255, 255)};    //цвет текста

void setup() {
  matrix.begin();
  matrix.setTextWrap(false);
  matrix.setBrightness(30);                       //яркость букв
  matrix.setTextColor(colors[0]);
}

int x    = matrix.width();
int pass = 0;

void loop() {
  matrix.fillScreen(12);                           //Яркость фона
  matrix.setCursor(x, 5);                         //Расположение текста-выше, ниже  
  matrix.print(utf8rus("Ардуино для начинающих. С Новым 2021 годом. Ура!!! "));
  if(--x < -290) {                                //Чем больше букв тем больше число 
    x = matrix.width();
    if(++pass >= 5) pass = 0;                     //Количество цветов текста
    matrix.setTextColor(colors[pass]);
  }
  matrix.show();
  delay(100);                                      //скорость текста Чем ниже число, тем быстрее
} 

String utf8rus(String source)
{
  int i,k;
  String target;
  unsigned char n;
  char m[2] = { '0', '\0' };

  k = source.length(); i = 0;

  while (i < k) {
    n = source[i]; i++;

    if (n >= 0xBF){
      switch (n) {
        case 0xD0: {
          n = source[i]; i++;
          if (n == 0x81) { n = 0xA8; break; }
          if (n >= 0x90 && n <= 0xBF) n = n + 0x2F;
          break;
        }
        case 0xD1: {
          n = source[i]; i++;
          if (n == 0x91) { n = 0xB7; break; }
          if (n >= 0x80 && n <= 0x8F) n = n + 0x6F;
          break;
        }
      }
    }
    m[0] = n; target = target + String(m);
  }
return target;
}
